package launcher;

import javafx.application.Application;
import javafx.beans.property.SimpleStringProperty;
import javafx.beans.property.StringProperty;
import javafx.stage.Stage;
import model.*;
import view.CapteurView;
import view.ImageCtrlView;
import view.ThermostatView;
import view.TreeViewCtrl;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class Launch extends Application {
    public static void main(String[] args) {
        launch(args);
    }

    @Override
    public void start(Stage primaryStage) throws IOException, InterruptedException {
        // Creation des capteurs
        UnitCapteur captorC = new UnitCapteur(1,new SimpleStringProperty("Capteur CPU"),new StrategyCPU());
        UnitCapteur captorR = new UnitCapteur(2,new SimpleStringProperty("Capteur Random"),new StrategyRandom());
        CapteurVirtuel captorV = new CapteurVirtuel(5,new SimpleStringProperty("Capteur Virtuel"));

        // Ajout des capteurs dans la collections du capteur virtuel
        captorV.addCapteur(captorC,1);
        captorV.addCapteur(captorR,1);
        for (Map.Entry<CapteurAbstrait, Integer> entry : captorV.getCapteurs().entrySet()) {
            CapteurAbstrait c = entry.getKey();
            c.genTemp();
        }
        captorV.genTemp();
        ArrayList<CapteurAbstrait> capteurs = new ArrayList<>();
        capteurs.add(captorC);
        capteurs.add(captorR);
        capteurs.add(captorV);

        // FXML NOT WORKING
        Stage thermostatStage = new Stage();
        TreeViewCtrl treeViewCtrl = new TreeViewCtrl(capteurs,"view/TreeView.fxml","treeView");
        treeViewCtrl.show();
        Thread t = new Thread() {
            public void run() {
                while (true) {
                    for (Map.Entry<CapteurAbstrait, Integer> entry : captorV.getCapteurs().entrySet()) {
                        CapteurAbstrait c = entry.getKey();
                        c.genTemp();
                    }
                    captorV.genTemp();
                    try {
                        /*((ImageCtrlView) capteurView).changeImage();
                        System.out.println(captorV.getNom() + ": " + captorV.getTemp().getValue() + " °C");
                        for (Map.Entry<CapteurAbstrait, Integer> entry : captorV.getCapteurs().entrySet()) {
                            CapteurAbstrait c = entry.getKey();
                            System.out.println(c.getNom() + ": " + c.getTemp().getValue() + " °C");
                        }*/
                        sleep(4000);
                    } catch (InterruptedException e) {
                        throw new RuntimeException(e);
                    }
                }
            }
        };
        t.start();
    }
}

