package model;

import javafx.beans.property.ObjectProperty;
import javafx.beans.property.SimpleObjectProperty;
import javafx.beans.property.SimpleStringProperty;
import javafx.beans.property.StringProperty;

public abstract class CapteurAbstrait {
    private int id;
    private StringProperty nom;
    private ObjectProperty<Double> temp = new SimpleObjectProperty<>();

    CapteurAbstrait(int id, StringProperty nom){
        this.id = id;
        this.nom = nom;
        this.temp.setValue(0.0);
    }
    public abstract void genTemp();

    /* Getters - Setters */
    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public StringProperty getNom() {
        return this.nom;
    }

    public void setNom(StringProperty nom) {
        this.nom = nom;
    }

    public ObjectProperty<Double> getTemp() {
        return temp;
    }

    public void setTemp(double pTemp) {
        this.temp.setValue(pTemp);
    }

    public abstract <T> T accept (Visitor<T> v);

}
